Package org.spongepowered.asm.mixin.injection.modify

## Class AfterStoreLocal

- java.lang.Object
- - org.spongepowered.asm.mixin.injection.InjectionPoint
  - - org.spongepowered.asm.mixin.injection.modify.BeforeLoadLocal
    - - org.spongepowered.asm.mixin.injection.modify.AfterStoreLocal

-     public class AfterStoreLocal
      extends BeforeLoadLocal

  This injection point is a companion for the `ModifyVariable` injector which searches for STORE operations which match the local variables described by the injector's defined discriminators.

  This allows you consumers to specify an injection immediately after a local variable is written in a method. Specify an `ordinal` of `n` to match the n + 1th access of the variable in question.

  ordinal
    The ordinal position of the STORE opcode for the matching local variable to search for, if not specified then the injection point returns all opcodes for which the parent annotation's discriminators match. The default value is -1 which supresses ordinal checking.

  Example:

  >        @ModifyVariable(
  >            method = "md",
  >            ordinal = 1,
  >            at = @At(
  >                value = "STORE",
  >                ordinal = 0
  >            )
  >        )

  Note that if value is the only parameter specified, it can be omitted:

  >        @At("STORE")

  Important Note: Unlike other standard injection points, this class matches the insn immediately after the matching point.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.spongepowered.asm.mixin.injection.InjectionPoint

      `InjectionPoint.AtCode, InjectionPoint.Flags, InjectionPoint.RestrictTargetLevel, InjectionPoint.Specifier`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected IMixinContext` | `mixin` |

    - ### Fields inherited from class org.spongepowered.asm.mixin.injection.modify.BeforeLoadLocal

      `discriminator, opcode, ordinal, returnType`

    - ### Fields inherited from class org.spongepowered.asm.mixin.injection.InjectionPoint

      `DEFAULT_ALLOWED_SHIFT_BY, MAX_ALLOWED_SHIFT_BY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AfterStoreLocal​(InjectionPointData data)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `find​(java.lang.String desc, org.objectweb.asm.tree.InsnList insns, java.util.Collection<org.objectweb.asm.tree.AbstractInsnNode> nodes)` | Find injection points in the supplied insn list

    - ### Methods inherited from class org.spongepowered.asm.mixin.injection.modify.BeforeLoadLocal

      `addMessage, toString, toString`

    - ### Methods inherited from class org.spongepowered.asm.mixin.injection.InjectionPoint

      `after, and, before, checkPriority, getAtCode, getId, getSlice, getSpecifier, getTargetRestriction, nextNode, or, parse, parse, parse, parse, parse, parse, parse, parse, register, register, setTargetRestriction, shift`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### mixin

          protected final IMixinContext mixin

  - ### Constructor Detail

    - #### AfterStoreLocal

          public AfterStoreLocal​(InjectionPointData data)

  - ### Method Detail

    - #### find

          public boolean find​(java.lang.String desc,
                              org.objectweb.asm.tree.InsnList insns,
                              java.util.Collection<org.objectweb.asm.tree.AbstractInsnNode> nodes)

      Description copied from class: `InjectionPoint`
      Find injection points in the supplied insn list
      Specified by:
        `find` in class `InjectionPoint`
      Parameters:
        `desc` - Method descriptor, supplied to allow return types and arguments etc. to be determined
        `insns` - Insn list to search in, the strategy MUST ONLY add nodes from this list to the `nodes` collection
        `nodes` - Collection of nodes to populate. Injectors should NOT make any assumptions about the state of this collection and should only call the add() method
      Returns:
        true if one or more injection points were found